#include <netinet/in.h>
#include <errno.h>
#include <netinet/tcp.h>
#include <arpa/inet.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <netdb.h>

/* This is a brute hack */
#ifdef SOLARIS
#define SOCK_STREAM 1
#endif

extern int errno;

/* int get_connection(char *hostname, int port)
   attempts to connect to hostname on port
 */

int get_connection(char *hostname, int port)
{
     struct sockaddr_in sa;
     struct hostent *hp;
     int sckfd;

     if ((hp = gethostbyname(hostname)) == NULL) {
	  errno = ECONNREFUSED;
	  return (-1);
     }
     bzero(&sa, sizeof(sa));
     bcopy(hp->h_addr, (char *) &sa.sin_addr, hp->h_length);
     sa.sin_family = hp->h_addrtype;
     sa.sin_port = htons((u_short) port);
     if ((sckfd = socket(hp->h_addrtype, SOCK_STREAM, 0)) < 0)
	  return (-1);
     if (connect(sckfd, (struct sockaddr *) &sa, sizeof(sa)) < 0) {
	  close(sckfd);
	  return (-1);
     }
     return (sckfd);
}
