#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <termios.h>
#include <fcntl.h>

int plen = 100;
main() {
	char pass[plen];
	int i, j, fl;
	struct termios *tcattr, *tcorig;
	fd_set t;

	tcattr = (struct termios *)malloc(sizeof(struct termios));
	tcgetattr(0, tcattr);
	tcorig = (struct termios *)malloc(sizeof(struct termios));
	tcgetattr(0, tcorig);

	tcattr->c_lflag = 0;
	
	i = j = 0;
#define PROMPT "plaintext: (len:   0) "
	write(1, (void *)PROMPT, strlen(PROMPT));
	fl = fcntl(0, F_GETFL);
	fl &= ~O_NONBLOCK;
	fcntl(0, F_SETFL, fl);

	tcsetattr(0, TCSADRAIN, tcattr);

	while(j == 0) {
		FD_ZERO(&t);
		FD_SET(0, &t);
		select(1, &t, NULL, NULL, NULL);
		read(0, (void *)&pass[i], 1);
		if(pass[i] == '\r' || pass[i] == '\n' || pass[i] == 3) {
			if(pass[i] == 3) {
				tcsetattr(0, TCSADRAIN, tcorig);
				printf("\n");
				exit(0);
			}
			j=1;
			pass[i] = 0;
		} else if (pass[i] == '\x08' || pass[i] == '\x7f') {
			pass[i] = 0;
			if(i > 0) {
				char s[50];
				bzero(s, 50);
				snprintf(s, 50, "\x1b[%iD%3i\x1b[%iC \x1b[1D", i+5, i-1, i+1);
				i--;
				pass[i] = 0;
				write(1, (void *)s, strlen(s));
			}
		} else if (pass[i] == '\x1a') {
			pass[i] = 0;
			kill(getpid(), 19);
		} else if (pass[i] == '\x1c') {
			kill(getpid(), 3);
		} else {
			if(i < plen) {
				char s[25];
				bzero(s, 25);
				snprintf(s, 25, "\x1b[%iD%3i\x1b[%iC*", i+5, i+1, i+2);
				write(1, (void *)s, strlen(s));
				i++;
			}
		}
	}

	tcsetattr(0, TCSADRAIN, tcorig);

	printf("\n");

	{
		char salt[2];
		char saltchars[] = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890./";
		int nchars=64;
		int p;
		FILE *t;
		t = fopen("/dev/urandom", "r");
		p = fgetc(t) % 64;
		salt[0] = saltchars[p];
		p = fgetc(t) % 64;
		salt[1] = saltchars[p];
		fclose(t);
		printf("crypted: %s\n", crypt(pass, salt));
	}
	exit(0);
}


	
