#include <stdio.h>
#include <string.h>
#include "struct.h"
#include "stats.h"
#include "defines.h"

extern struct msg_use msgs;
extern char *t, *tmp;

void 
m_server (struct fd_list *fd, char **av, int ac)
{
  if (!strcasecmp (t, "SERVER"))
    {
      msgs.server.use++;
      msgs.server.bytes += strlen (tmp);
    }
  else if (!strcasecmp (t, "SQUIT"))
    {
      msgs.squit.use++;
      msgs.squit.bytes += strlen (tmp);
    }
  irc_fprintf (fd->sok, ":%s 510 %s :We don't do linking yet.\r\n", NAME, (fd->nick[0] != 0 ? fd->nick : "*"));
  irc_fflush (fd->sok);
  return;
}

#if 0

char my_numeric:6;
const char numerics[64] =
{'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H',
 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P',
 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X',
 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f',
 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n',
 'o', 'p', 'q', 'r', 's', 't', 'u', 'v',
 'w', 'x', 'y', 'z', '0', '1', '2', '3',
 '4', '5', '6', '7', '8', '9', '[', ']'
};
/* m_server -
   rfc1459-compliant linking:
   av[0] = cmd
   av[1] = server name
   av[2] = hopcount
   av[3] = server info

   Undernet P09 linking:
   av[0] = cmd
   av[1] = server name
   av[2] = hopcount
   av[3] = start timestamp
   av[4] = link timestamp
   av[5] = protocol version [P09]
   av[6] = server info

   Undernet P10 linking:
   av[0] = cmd
   av[1] = server name
   av[2] = hopcount
   av[3] = start timestamp
   av[4] = link timestamp
   av[5] = protocol version [P10]
   av[6] = server numeric & nick numeric mask of server
   av[7] = 0 (unused)
   av[8] = server info
 */

void 
m_server (struct fd_list *fd, char **av, int ac)
{


  void m_connect (struct fd_list *fd, char **av, int ac)
  {


#endif
